!! *--------   DSL Code Generator, Simpow   ----------------------
!! *
!! *           Name       : PSS2B
!! *           Explanation: 
!! *                        
!! *           DSL Code Generator, release 1.3, 2005-02-10.
!! *           Copyright STRI AB, Sweden.
!! *--------------------------------------------------------------
!! Department : 
!! Designed by: Anders Hammer
!! Checked by : 
!! Approved by: 
!! Date       : 
!! *--------------------------------------------------------------

PROCESS PSS2B(KS1,FMIN,FMAX,PMIN,
& PMAX,PEG,TP,FIFI,
& KS2,KS3,T8,T9,
& T7,TW4,TW3,T6,
& TW2,TW1,TF,PSSMIN,
& PSSMAX,T11,T4,T2,
& T10,T3,T1,VS,
& VS0)
EXTERNAL KS1,FMIN,FMAX,PMIN
EXTERNAL PMAX,PEG,TP,FIFI
EXTERNAL KS2,KS3,T8,T9
EXTERNAL T7,TW4,TW3,T6
EXTERNAL TW2,TW1,TF,PSSMIN
EXTERNAL PSSMAX,T11,T4,T2
EXTERNAL T10,T3,T1,VS0
!! End of external declarations.
REAL     KS1,FMIN,FMAX,PMIN
REAL     PMAX,PEG,PSS2B_111,TP
REAL     FIFI,FREQ,KS2,KS3
REAL     T8,T9,T7,TW4
REAL     TW3,T6,TW2,TW1
REAL     TF,PSSMIN,PSSMAX,T11
REAL     T4,T2,T10,T3
REAL     T1,PSS2B_114,PSS2B_117,F
REAL     P,PSS2B_89,PSS2B_78,PSS2B_88
REAL     INTER_1,INTER_2,PSS2B_79,INTER_3
REAL     INTER_4,PSS2B_87,PSS2B_80,PSS2B_86
REAL     INTER_5,INTER_6,PSS2B_81,INTER_7
REAL     INTER_8,F1,P1,P2
REAL     F2,PSS2B_104,INTER_9
REAL     PSS2B_105,PSS2B_106,F3,SIGNAL1
REAL     PSS2B_109,REF/*/,SIGNAL2,VS0
REAL     PSS2B_55,PSS2B_56,INTER_10
REAL     PSS2B_57,INTER_11,PSS2B_65,INTER_12
REAL     VS
INTEGER  CHECK_OF_LIMITS
!! End of real and integer declarations.
PLOT     FREQ,F,P,F1
PLOT     P1,P2,F2,F3
PLOT     SIGNAL1,SIGNAL2
STATE    PSS2B_114,PSS2B_117,INTER_2
STATE    INTER_4,INTER_6,INTER_8
STATE    F1,P1,INTER_9
STATE    PSS2B_105,PSS2B_106,F3,INTER_10
STATE    INTER_11,INTER_12,CHECK_OF_LIMITS/0/
!! End of state declarations.
   IF (START) THEN
   ENDIF
!! End of parameter setting and initiations of PSS2B.

!! Here starts the dynamic part of process PSS2B.
   PSS2B_111=PEG
   FREQ=FIFI
!! First-order filter with filter constant TP.
   IF (START00) THEN
      PSS2B_114=PSS2B_111
   ELSE
      PSS2B_114: PSS2B_114=PSS2B_111-TP*.D/DT.PSS2B_114
   ENDIF
!! First-order filter with filter constant TF.
   IF (START00) THEN
      PSS2B_117=FREQ
   ELSE
      PSS2B_117: PSS2B_117=FREQ-TF*.D/DT.PSS2B_117
   ENDIF
!! Limiter, FMIN <= F <= FMAX.
!! Checking the limits of the Limit function.
   IF (FMAX.LT.FMIN) THEN
      STOP'The upper limit is lower than the lower limit.'
   ENDIF
   IF (PSS2B_117.GE.FMAX.AND..NOT.START) THEN
      F=FMAX
      PRINT-I'F is at maximum limit.'
   ELSEIF (PSS2B_117.LE.FMIN.AND..NOT.START) THEN
      F=FMIN
      PRINT-I'F is at minimum limit.'
   ELSE
      F=PSS2B_117
      PRINT'F is within limits.'
   ENDIF
!! Limiter, PMIN <= P <= PMAX.
!! Checking the limits of the Limit function.
   IF (PMAX.LT.PMIN) THEN
      STOP'The upper limit is lower than the lower limit.'
   ENDIF
   IF (PSS2B_114.GE.PMAX.AND..NOT.START) THEN
      P=PMAX
      PRINT-I'P is at maximum limit.'
   ELSEIF (PSS2B_114.LE.PMIN.AND..NOT.START) THEN
      P=PMIN
      PRINT-I'P is at minimum limit.'
   ELSE
      P=PSS2B_114
      PRINT'P is within limits.'
   ENDIF
!! Multiplication of two signals.
   PSS2B_89=TW3*P
!! Multiplication of two signals.
   PSS2B_78=TW1*F
!! Filtered deriving function s/(1+sTW3).
   INTER_1=PSS2B_89/TW3
   INTER_2: INTER_2=INTER_1-TW3*.D/DT.INTER_2
   PSS2B_88=INTER_1-INTER_2
!! Filtered deriving function s/(1+sTW1).
   INTER_3=PSS2B_78/TW1
   INTER_4: INTER_4=INTER_3-TW1*.D/DT.INTER_4
   PSS2B_79=INTER_3-INTER_4
!! Multiplication of two signals.
   PSS2B_87=TW4*PSS2B_88
!! Multiplication of two signals.
   PSS2B_80=TW2*PSS2B_79
!! Filtered deriving function s/(1+sTW4).
   INTER_5=PSS2B_87/TW4
   INTER_6: INTER_6=INTER_5-TW4*.D/DT.INTER_6
   PSS2B_86=INTER_5-INTER_6
!! Filtered deriving function s/(1+sTW2).
   INTER_7=PSS2B_80/TW2
   INTER_8: INTER_8=INTER_7-TW2*.D/DT.INTER_8
   PSS2B_81=INTER_7-INTER_8
!! First-order filter with filter constant T6.
   IF (START00) THEN
      F1=PSS2B_81
   ELSE
      F1: F1=PSS2B_81-T6*.D/DT.F1
   ENDIF
!! First-order filter with filter constant T7
!! and the constant KS2 in the numerator.
   IF (START00) THEN
      P1=KS2*PSS2B_86
   ELSE
      P1: P1=KS2*PSS2B_86-T7*.D/DT.P1
   ENDIF
!! Multiplication of two signals.
   P2=KS3*P1
!! Summation of two signals.
   F2=F1+P2
!! Filter (1+sT8)/(1+sT9).
   IF (START00) THEN
      INTER_9=F2*(1-T8/T9)
   ELSE
      INTER_9: INTER_9=F2*(1-T8/T9)-T9*.D/DT.INTER_9
   ENDIF
   PSS2B_104=T8/T9*F2+INTER_9
!! First-order filter with filter constant T9.
   IF (START00) THEN
      PSS2B_105=PSS2B_104
   ELSE
      PSS2B_105: PSS2B_105=PSS2B_104-T9*.D/DT.PSS2B_105
   ENDIF
!! First-order filter with filter constant T9.
   IF (START00) THEN
      PSS2B_106=PSS2B_105
   ELSE
      PSS2B_106: PSS2B_106=PSS2B_105-T9*.D/DT.PSS2B_106
   ENDIF
!! First-order filter with filter constant T9.
   IF (START00) THEN
      F3=PSS2B_106
   ELSE
      F3: F3=PSS2B_106-T9*.D/DT.F3
   ENDIF
!! Summation of two signals.
   SIGNAL1=F3-P1
!! Changes the sign of a signal.
   PSS2B_109=-SIGNAL1
!! A signal subtracted to the reference, Reference.
   SIGNAL2=REF-PSS2B_109
!! Multiplication of two signals.
   PSS2B_55=KS1*SIGNAL2
!! Filter (1+sT1)/(1+sT2).
   IF (START00) THEN
      INTER_10=PSS2B_55*(1-T1/T2)
   ELSE
      INTER_10: INTER_10=PSS2B_55*(1-T1/T2)-T2*.D/DT.INTER_10
   ENDIF
   PSS2B_56=T1/T2*PSS2B_55+INTER_10
!! Filter (1+sT3)/(1+sT4).
   IF (START00) THEN
      INTER_11=PSS2B_56*(1-T3/T4)
   ELSE
      INTER_11: INTER_11=PSS2B_56*(1-T3/T4)-T4*.D/DT.INTER_11
   ENDIF
   PSS2B_57=T3/T4*PSS2B_56+INTER_11
!! Filter (1+sT10)/(1+sT11).
   IF (START00) THEN
      INTER_12=PSS2B_57*(1-T10/T11)
   ELSE
      INTER_12: INTER_12=PSS2B_57*(1-T10/T11)-T11*.D/DT.INTER_12
   ENDIF
   PSS2B_65=T10/T11*PSS2B_57+INTER_12
!! Limiter, PSSMIN <= VS <= PSSMAX.
!! Checking the limits of the Limit function.
   IF (PSSMAX.LT.PSSMIN) THEN
      STOP'The upper limit is lower than the lower limit.'
   ENDIF
   IF (PSS2B_65.GE.PSSMAX.AND..NOT.START) THEN
      VS=PSSMAX
      PRINT-I'VS is at maximum limit.'
   ELSEIF (PSS2B_65.LE.PSSMIN.AND..NOT.START) THEN
      VS=PSSMIN
      PRINT-I'VS is at minimum limit.'
   ELSE
      VS=PSS2B_65
      PRINT'VS is within limits.'
   ENDIF
!! Initial control of some of the block diagrams.
   IF (START) THEN
!! A check of the filtered deriving function s/(1+sTW3).
      IF (TW3.LE.0) THEN
         STOP'Time constant TW3 in block s/(1+sTF) less or equal zero!'
      ENDIF
!! A check of the filtered deriving function s/(1+sTW1).
      IF (TW1.LE.0) THEN
         STOP'Time constant TW1 in block s/(1+sTF) less or equal zero!'
      ENDIF
!! A check of the filtered deriving function s/(1+sTW4).
      IF (TW4.LE.0) THEN
         STOP'Time constant TW4 in block s/(1+sTF) less or equal zero!'
      ENDIF
!! A check of the filtered deriving function s/(1+sTW2).
      IF (TW2.LE.0) THEN
         STOP'Time constant TW2 in block s/(1+sTF) less or equal zero!'
      ENDIF
!! Check of the filter (1+sT8)/(1+sT9).
      IF (T9.LE.0) THEN
         STOP'Time constant T9 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Checks start conditions by setting REF.
      REF: VS=VS0
!! Check of the filter (1+sT1)/(1+sT2).
      IF (T2.LE.0) THEN
         STOP'Time constant T2 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sT3)/(1+sT4).
      IF (T4.LE.0) THEN
         STOP'Time constant T4 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sT10)/(1+sT11).
      IF (T11.LE.0) THEN
         STOP'Time constant T11 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
   ENDIF
!! End of initial control of some of the block diagrams.
!! Control of block diagram outputs within given limits.
   IF (.NOT.START.AND.CHECK_OF_LIMITS.EQ.0) THEN
      IF (PSS2B_117.GE.FMAX) THEN
         PRINT-I'F is at maximum limit.'
      ELSEIF (PSS2B_117.LE.FMIN) THEN
         PRINT-I'F is at minimum limit.'
      ENDIF
      IF (PSS2B_114.GE.PMAX) THEN
         PRINT-I'P is at maximum limit.'
      ELSEIF (PSS2B_114.LE.PMIN) THEN
         PRINT-I'P is at minimum limit.'
      ENDIF
      IF (PSS2B_65.GE.PSSMAX) THEN
         PRINT-I'VS is at maximum limit.'
      ELSEIF (PSS2B_65.LE.PSSMIN) THEN
         PRINT-I'VS is at minimum limit.'
      ENDIF
      CHECK_OF_LIMITS=1
   ENDIF
!! End of control of block diagram outputs within given limits.
END
!! End of PSS2B.                :-|
