!! *--------   DSL Code Generator, Simpow   ----------------------
!! *
!! *           Name       : PSS4B
!! *           Explanation: 
!! *                        
!! *           DSL Code Generator, release 1.3, 2005-02-10.
!! *           Copyright STRI AB, Sweden.
!! *--------------------------------------------------------------
!! Department : 
!! Designed by: Anders Hammer
!! Checked by : 
!! Approved by: 
!! Date       : 
!! *--------------------------------------------------------------

PROCESS PSS4B(VSTmax,KST,PEG,W,
& TWOH,KH1,KH2,TH7,
& KH17,TH8,TH9,TH10,
& TH11,TH12,TH1,KH11,
& TH2,TH3,TH4,TH5,
& TH6,KH,VHmin,VHmax,
& KI1,KI2,TI7,KI17,
& TI8,TI9,TI10,TI11,
& TI12,TI1,KI11,TI2,
& TI3,TI4,TI5,TI6,
& KI,VImin,VImax,KL1,
& KL2,TL7,KL17,TL8,
& TL9,TL10,TL11,TL12,
& TL1,KL11,TL2,TL3,
& TL4,TL5,TL6,KL,
& VLmin,VLmax,VSTmin,D0,
& D1,D2,C0,C1,
& C2,C3,B0,B1,
& A0,A1,A2,VS,
& VS0)
EXTERNAL VSTmax,KST,PEG,W
EXTERNAL TWOH,KH1,KH2,TH7
EXTERNAL KH17,TH8,TH9,TH10
EXTERNAL TH11,TH12,TH1,KH11
EXTERNAL TH2,TH3,TH4,TH5
EXTERNAL TH6,KH,VHmin,VHmax
EXTERNAL KI1,KI2,TI7,KI17
EXTERNAL TI8,TI9,TI10,TI11
EXTERNAL TI12,TI1,KI11,TI2
EXTERNAL TI3,TI4,TI5,TI6
EXTERNAL KI,VImin,VImax,KL1
EXTERNAL KL2,TL7,KL17,TL8
EXTERNAL TL9,TL10,TL11,TL12
EXTERNAL TL1,KL11,TL2,TL3
EXTERNAL TL4,TL5,TL6,KL
EXTERNAL VLmin,VLmax,VSTmin,D0
EXTERNAL D1,D2,C0,C1
EXTERNAL C2,C3,B0,B1
EXTERNAL A0,A1,A2,VS0
!! End of external declarations.
REAL     VSTmax,KST,PEG,PE1
REAL     W,W1,TWOH,TH14/*/
REAL     TH13/*/,KH1,KH2,TH7
REAL     KH17,TH8,TH9,TH10
REAL     TH11,TH12,TH1,KH11
REAL     TH2,TH3,TH4,TH5
REAL     TH6,KH,VHmin,VHmax
REAL     TI14/*/,TI13/*/,KI1,KI2
REAL     TI7,KI17,TI8,TI9
REAL     TI10,TI11,TI12,TI1
REAL     KI11,TI2,TI3,TI4
REAL     TI5,TI6,KI,VImin
REAL     VImax,TL14/*/,TL13/*/,KL1
REAL     KL2,TL7,KL17,TL8
REAL     TL9,TL10,TL11,TL12
REAL     TL1,KL11,TL2,TL3
REAL     TL4,TL5,TL6,KL
REAL     VLmin,VLmax,VSTmin,D0
REAL     D1,D2,C0
REAL     C1,C2,C3
REAL     PE2,INTER_1,INTER_2
REAL     INTER_3,B0,B1
REAL     A0,A1,A2
REAL     W2,INTER_4,INTER_5
REAL     PE3,H5,H1,I5
REAL     I1,L5,L1,H6
REAL     INTER_6,H2,INTER_7
REAL     I6,INTER_8,I2,INTER_9
REAL     L6,INTER_10,L2,INTER_11
REAL     L3,INTER_12,H7,INTER_13
REAL     H8,INTER_14,H3,INTER_15
REAL     H4,INTER_16,I7,INTER_17
REAL     I8,INTER_18,I3,INTER_19
REAL     I4,INTER_20,L7,INTER_21
REAL     L8,INTER_22,L4,INTER_23
REAL     L9,H9,I9,L10
REAL     VL,H10,I10,VH
REAL     VI,VST1,VST2,PSS4B_114
REAL     REF/*/,PSS4B_113,VS0,PSS4B_112
REAL     VS
INTEGER  CHECK_OF_LIMITS
!! End of real and integer declarations.
PLOT     PE1,PE2,W2,PE3
PLOT     H8,H4,I8,I4
PLOT     L8,L4,VL,VH
PLOT     VI,VST2
STATE    INTER_1,INTER_2,INTER_3,INTER_4
STATE    INTER_5,PE3,INTER_6
STATE    INTER_7,INTER_8,INTER_9
STATE    INTER_10,INTER_11,INTER_12
STATE    INTER_13,INTER_14,INTER_15
STATE    INTER_16,INTER_17,INTER_18
STATE    INTER_19,INTER_20,INTER_21
STATE    INTER_22,INTER_23,CHECK_OF_LIMITS/0/
!! End of state declarations.
   IF (START) THEN
      TH14=1.0
      TH13=1.0
      TI14=1.0
      TI13=1.0
      TL14=1.0
      TL13=1.0
   ENDIF
!! End of parameter setting and initiations of PSS4B.

!! Here starts the dynamic part of process PSS4B.
   PE1=PEG
   W1=W
!! A general transfer function of order 2 in the
!! numerator and of order 3 in the denominator.
   INTER_3: INTER_1=.D/DT.INTER_3
   INTER_1: INTER_2=.D/DT.INTER_1
   INTER_2: PE1-C0*INTER_3-C1*INTER_1
&      -C2*INTER_2=C3*.D/DT.INTER_2
   PE2=D0*INTER_3+D1*INTER_1+D2*INTER_2
!! A general transfer function of order 1 in the
!! numerator and of order 2 in the denominator.
   INTER_5: INTER_4=.D/DT.INTER_5
   INTER_4: W1-A0*INTER_5-A1*INTER_4
&      =A2*.D/DT.INTER_4
   W2=B0*INTER_5+B1*INTER_4
!! First-order filter with filter constant TWOH.
   IF (START00) THEN
      PE3=PE2
   ELSE
      PE3: PE3=PE2-TWOH*.D/DT.PE3
   ENDIF
!! Multiplication of two signals.
   H5=KH2*PE3
!! Multiplication of two signals.
   H1=KH1*PE3
!! Multiplication of two signals.
   I5=KI2*W2
!! Multiplication of two signals.
   I1=KI1*W2
!! Multiplication of two signals.
   L5=KL2*W2
!! Multiplication of two signals.
   L1=KL1*W2
!! Filter (KH17+sTH7)/(TH14+sTH8).
   IF (START00) THEN
      INTER_6=H5*(KH17/TH14-TH7/TH8)
   ELSE
      INTER_6: INTER_6=(H5*(KH17-TH7*TH14/TH8)-TH8*.D/DT.INTER_6)/TH14
   ENDIF
   H6=TH7/TH8*H5+INTER_6
!! Filter (KH11+sTH1)/(TH13+sTH2).
   IF (START00) THEN
      INTER_7=H1*(KH11/TH13-TH1/TH2)
   ELSE
      INTER_7: INTER_7=(H1*(KH11-TH1*TH13/TH2)-TH2*.D/DT.INTER_7)/TH13
   ENDIF
   H2=TH1/TH2*H1+INTER_7
!! Filter (KI17+sTI7)/(TI14+sTI8).
   IF (START00) THEN
      INTER_8=I5*(KI17/TI14-TI7/TI8)
   ELSE
      INTER_8: INTER_8=(I5*(KI17-TI7*TI14/TI8)-TI8*.D/DT.INTER_8)/TI14
   ENDIF
   I6=TI7/TI8*I5+INTER_8
!! Filter (KI11+sTI1)/(TI13+sTI2).
   IF (START00) THEN
      INTER_9=I1*(KI11/TI13-TI1/TI2)
   ELSE
      INTER_9: INTER_9=(I1*(KI11-TI1*TI13/TI2)-TI2*.D/DT.INTER_9)/TI13
   ENDIF
   I2=TI1/TI2*I1+INTER_9
!! Filter (KL17+sTL7)/(TL14+sTL8).
   IF (START00) THEN
      INTER_10=L5*(KL17/TL14-TL7/TL8)
   ELSE
      INTER_10: INTER_10=(L5*(KL17-TL7*TL14/TL8)-TL8*.D/DT.INTER_10)/TL14
   ENDIF
   L6=TL7/TL8*L5+INTER_10
!! Filter (KL11+sTL1)/(TL13+sTL2).
   IF (START00) THEN
      INTER_11=L1*(KL11/TL13-TL1/TL2)
   ELSE
      INTER_11: INTER_11=(L1*(KL11-TL1*TL13/TL2)-TL2*.D/DT.INTER_11)/TL13
   ENDIF
   L2=TL1/TL2*L1+INTER_11
!! Filter (1+sTL3)/(1+sTL4).
   IF (START00) THEN
      INTER_12=L2*(1-TL3/TL4)
   ELSE
      INTER_12: INTER_12=L2*(1-TL3/TL4)-TL4*.D/DT.INTER_12
   ENDIF
   L3=TL3/TL4*L2+INTER_12
!! Filter (1+sTH9)/(1+sTH10).
   IF (START00) THEN
      INTER_13=H6*(1-TH9/TH10)
   ELSE
      INTER_13: INTER_13=H6*(1-TH9/TH10)-TH10*.D/DT.INTER_13
   ENDIF
   H7=TH9/TH10*H6+INTER_13
!! Filter (1+sTH11)/(1+sTH12).
   IF (START00) THEN
      INTER_14=H7*(1-TH11/TH12)
   ELSE
      INTER_14: INTER_14=H7*(1-TH11/TH12)-TH12*.D/DT.INTER_14
   ENDIF
   H8=TH11/TH12*H7+INTER_14
!! Filter (1+sTH3)/(1+sTH4).
   IF (START00) THEN
      INTER_15=H2*(1-TH3/TH4)
   ELSE
      INTER_15: INTER_15=H2*(1-TH3/TH4)-TH4*.D/DT.INTER_15
   ENDIF
   H3=TH3/TH4*H2+INTER_15
!! Filter (1+sTH5)/(1+sTH6).
   IF (START00) THEN
      INTER_16=H3*(1-TH5/TH6)
   ELSE
      INTER_16: INTER_16=H3*(1-TH5/TH6)-TH6*.D/DT.INTER_16
   ENDIF
   H4=TH5/TH6*H3+INTER_16
!! Filter (1+sTI9)/(1+sTI10).
   IF (START00) THEN
      INTER_17=I6*(1-TI9/TI10)
   ELSE
      INTER_17: INTER_17=I6*(1-TI9/TI10)-TI10*.D/DT.INTER_17
   ENDIF
   I7=TI9/TI10*I6+INTER_17
!! Filter (1+sTI11)/(1+sTI12).
   IF (START00) THEN
      INTER_18=I7*(1-TI11/TI12)
   ELSE
      INTER_18: INTER_18=I7*(1-TI11/TI12)-TI12*.D/DT.INTER_18
   ENDIF
   I8=TI11/TI12*I7+INTER_18
!! Filter (1+sTI3)/(1+sTI4).
   IF (START00) THEN
      INTER_19=I2*(1-TI3/TI4)
   ELSE
      INTER_19: INTER_19=I2*(1-TI3/TI4)-TI4*.D/DT.INTER_19
   ENDIF
   I3=TI3/TI4*I2+INTER_19
!! Filter (1+sTI5)/(1+sTI6).
   IF (START00) THEN
      INTER_20=I3*(1-TI5/TI6)
   ELSE
      INTER_20: INTER_20=I3*(1-TI5/TI6)-TI6*.D/DT.INTER_20
   ENDIF
   I4=TI5/TI6*I3+INTER_20
!! Filter (1+sTL9)/(1+sTL10).
   IF (START00) THEN
      INTER_21=L6*(1-TL9/TL10)
   ELSE
      INTER_21: INTER_21=L6*(1-TL9/TL10)-TL10*.D/DT.INTER_21
   ENDIF
   L7=TL9/TL10*L6+INTER_21
!! Filter (1+sTL11)/(1+sTL12).
   IF (START00) THEN
      INTER_22=L7*(1-TL11/TL12)
   ELSE
      INTER_22: INTER_22=L7*(1-TL11/TL12)-TL12*.D/DT.INTER_22
   ENDIF
   L8=TL11/TL12*L7+INTER_22
!! Filter (1+sTL5)/(1+sTL6).
   IF (START00) THEN
      INTER_23=L3*(1-TL5/TL6)
   ELSE
      INTER_23: INTER_23=L3*(1-TL5/TL6)-TL6*.D/DT.INTER_23
   ENDIF
   L4=TL5/TL6*L3+INTER_23
!! Summation of two signals.
   L9=L4-L8
!! Summation of two signals.
   H9=H4-H8
!! Summation of two signals.
   I9=I4-I8
!! Multiplication of two signals.
   L10=KL*L9
!! Limiter, VLmin <= VL <= VLmax.
!! Checking the limits of the Limit function.
   IF (VLmax.LT.VLmin) THEN
      STOP'The upper limit is lower than the lower limit.'
   ENDIF
   IF (L10.GE.VLmax.AND..NOT.START) THEN
      VL=VLmax
      PRINT-I'VL is at maximum limit.'
   ELSEIF (L10.LE.VLmin.AND..NOT.START) THEN
      VL=VLmin
      PRINT-I'VL is at minimum limit.'
   ELSE
      VL=L10
      PRINT'VL is within limits.'
   ENDIF
!! Multiplication of two signals.
   H10=KH*H9
!! Multiplication of two signals.
   I10=KI*I9
!! Limiter, VHmin <= VH <= VHmax.
!! Checking the limits of the Limit function.
   IF (VHmax.LT.VHmin) THEN
      STOP'The upper limit is lower than the lower limit.'
   ENDIF
   IF (H10.GE.VHmax.AND..NOT.START) THEN
      VH=VHmax
      PRINT-I'VH is at maximum limit.'
   ELSEIF (H10.LE.VHmin.AND..NOT.START) THEN
      VH=VHmin
      PRINT-I'VH is at minimum limit.'
   ELSE
      VH=H10
      PRINT'VH is within limits.'
   ENDIF
!! Limiter, VImin <= VI <= VImax.
!! Checking the limits of the Limit function.
   IF (VImax.LT.VImin) THEN
      STOP'The upper limit is lower than the lower limit.'
   ENDIF
   IF (I10.GE.VImax.AND..NOT.START) THEN
      VI=VImax
      PRINT-I'VI is at maximum limit.'
   ELSEIF (I10.LE.VImin.AND..NOT.START) THEN
      VI=VImin
      PRINT-I'VI is at minimum limit.'
   ELSE
      VI=I10
      PRINT'VI is within limits.'
   ENDIF
!! Summation of three signals.
   VST1=VL+VI+VH
!! Multiplication of two signals.
   VST2=KST*VST1
!! Changes the sign of a signal.
   PSS4B_114=-VST2
!! A signal subtracted to the reference, Reference.
   PSS4B_113=REF-PSS4B_114
!! Limiter, VSTmin <= PSS4B_112 <= VSTmax.
!! Checking the limits of the Limit function.
   IF (VSTmax.LT.VSTmin) THEN
      STOP'The upper limit is lower than the lower limit.'
   ENDIF
   IF (PSS4B_113.GE.VSTmax.AND..NOT.START) THEN
      PSS4B_112=VSTmax
      PRINT-I'PSS4B_112 is at maximum limit.'
   ELSEIF (PSS4B_113.LE.VSTmin.AND..NOT.START) THEN
      PSS4B_112=VSTmin
      PRINT-I'PSS4B_112 is at minimum limit.'
   ELSE
      PSS4B_112=PSS4B_113
      PRINT'PSS4B_112 is within limits.'
   ENDIF
!! Stabilizer output.
   VS=PSS4B_112
!! Initial control of some of the block diagrams.
   IF (START) THEN
!! Check of the filter (KH17+sTH7)/(TH14+sTH8).
      IF (TH8.LE.0) THEN
         STOP'Time constant TH8 in block (A+sB)/(C+sD) is',
&            ' less or equal zero!'
      ENDIF
!! Check of the filter (KH11+sTH1)/(TH13+sTH2).
      IF (TH2.LE.0) THEN
         STOP'Time constant TH2 in block (A+sB)/(C+sD) is',
&            ' less or equal zero!'
      ENDIF
!! Check of the filter (KI17+sTI7)/(TI14+sTI8).
      IF (TI8.LE.0) THEN
         STOP'Time constant TI8 in block (A+sB)/(C+sD) is',
&            ' less or equal zero!'
      ENDIF
!! Check of the filter (KI11+sTI1)/(TI13+sTI2).
      IF (TI2.LE.0) THEN
         STOP'Time constant TI2 in block (A+sB)/(C+sD) is',
&            ' less or equal zero!'
      ENDIF
!! Check of the filter (KL17+sTL7)/(TL14+sTL8).
      IF (TL8.LE.0) THEN
         STOP'Time constant TL8 in block (A+sB)/(C+sD) is',
&            ' less or equal zero!'
      ENDIF
!! Check of the filter (KL11+sTL1)/(TL13+sTL2).
      IF (TL2.LE.0) THEN
         STOP'Time constant TL2 in block (A+sB)/(C+sD) is',
&            ' less or equal zero!'
      ENDIF
!! Check of the filter (1+sTL3)/(1+sTL4).
      IF (TL4.LE.0) THEN
         STOP'Time constant TL4 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTH9)/(1+sTH10).
      IF (TH10.LE.0) THEN
         STOP'Time constant TH10 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTH11)/(1+sTH12).
      IF (TH12.LE.0) THEN
         STOP'Time constant TH12 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTH3)/(1+sTH4).
      IF (TH4.LE.0) THEN
         STOP'Time constant TH4 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTH5)/(1+sTH6).
      IF (TH6.LE.0) THEN
         STOP'Time constant TH6 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTI9)/(1+sTI10).
      IF (TI10.LE.0) THEN
         STOP'Time constant TI10 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTI11)/(1+sTI12).
      IF (TI12.LE.0) THEN
         STOP'Time constant TI12 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTI3)/(1+sTI4).
      IF (TI4.LE.0) THEN
         STOP'Time constant TI4 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTI5)/(1+sTI6).
      IF (TI6.LE.0) THEN
         STOP'Time constant TI6 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTL9)/(1+sTL10).
      IF (TL10.LE.0) THEN
         STOP'Time constant TL10 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTL11)/(1+sTL12).
      IF (TL12.LE.0) THEN
         STOP'Time constant TL12 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Check of the filter (1+sTL5)/(1+sTL6).
      IF (TL6.LE.0) THEN
         STOP'Time constant TL6 in block (1+sTC)/(1+sTB) less',
&            ' or equal zero!'
      ENDIF
!! Checks start conditions by setting REF.
      REF: VS=VS0
   ENDIF
!! End of initial control of some of the block diagrams.
!! Control of block diagram outputs within given limits.
   IF (.NOT.START.AND.CHECK_OF_LIMITS.EQ.0) THEN
      IF (L10.GE.VLmax) THEN
         PRINT-I'VL is at maximum limit.'
      ELSEIF (L10.LE.VLmin) THEN
         PRINT-I'VL is at minimum limit.'
      ENDIF
      IF (H10.GE.VHmax) THEN
         PRINT-I'VH is at maximum limit.'
      ELSEIF (H10.LE.VHmin) THEN
         PRINT-I'VH is at minimum limit.'
      ENDIF
      IF (I10.GE.VImax) THEN
         PRINT-I'VI is at maximum limit.'
      ELSEIF (I10.LE.VImin) THEN
         PRINT-I'VI is at minimum limit.'
      ENDIF
      IF (PSS4B_113.GE.VSTmax) THEN
         PRINT-I'PSS4B_112 is at maximum limit.'
      ELSEIF (PSS4B_113.LE.VSTmin) THEN
         PRINT-I'PSS4B_112 is at minimum limit.'
      ENDIF
      CHECK_OF_LIMITS=1
   ENDIF
!! End of control of block diagram outputs within given limits.
END
!! End of PSS4B.                :-(
