!! *--------   DSL Code Generator, Simpow   ----------------------
!! *
!! *           Name       : THYRAVR4_PSS
!! *           Explanation: Thyricon AVR, reconstructed.
!! *                        
!! *           DSL Code Generator, release 1.3, 2005-02-10.
!! *           Copyright STRI AB, Sweden.
!! *--------------------------------------------------------------
!! Department : 
!! Designed by: 
!! Checked by : 
!! Approved by: 
!! Date       : 
!! *--------------------------------------------------------------

PROCESS THYRAVR4_PSS(KP,KBR,TBR,OELf,
& MFCL,VS,VC,IMIN,
& IMAX,TD,TI,KD,
& TU,UF,UF0, REFTAB)                                  !AH revisjon REFTAB
EXTERNAL KP,KBR,TBR,OELf
EXTERNAL MFCL,VS,VC,IMIN
EXTERNAL IMAX,TD,TI,KD
EXTERNAL TU,UF0
EXTERNAL REFTAB                                   !AH revisjon
!! End of external declarations.
REAL     KP,KBR,TBR,OELf
REAL     MFCL,VS,VC,IMIN
REAL     IMAX,TD,TI,KD
REAL     TU,V1,REF/*/,V2
REAL     UF0,V7,V4,V5
REAL     INTER_1,INTER_2,V3,V6
REAL     V8,UC,UF
REAL     REFX                                     !AH revisjon
INTEGER  IREFTAB                                  !AH revisjon
INTEGER  CHECK_OF_LIMITS
!! End of real and integer declarations.
STATE   IREFTAB/1/                                !AH revisjon
ARRAY   REFTAB(*,2)                               !AH revisjon
PLOT     VS,VC,V3,V6
PLOT     V8,UC
STATE    V1,INTER_2,V6,UF
STATE    CHECK_OF_LIMITS/0/
!! End of state declarations.
   IF (START) THEN
   ENDIF
!!Here starts the reftab
IF(TIME.GE/0/.0.)THEN
    IF (NROW(REFTAB) .EQ.1 .AND.                              !AH revisjon REFTAB SEKVENS
&    REFTAB(1,1).EQ.-99999.AND.REFTAB(1,2).EQ.-99999.) THEN
    REFX=1.
    ELSE
    IF (IREFTAB.LT. NROW(REFTAB))THEN
   IF (TIME .GE/0/. REFTAB(IREFTAB+1,1))THEN
     IREFTAB=IREFTAB+1
     PRINT "DISCONTINUITY IN REFTAB"
   ENDIF
 ENDIF
 IF (IREFTAB.EQ. NROW(REFTAB)) THEN
   REFX = REFTAB(NROW(REFTAB),2)
 ELSE
   IF (REFTAB(IREFTAB+1,1)-REFTAB(IREFTAB,1) .NE/0/. 0.)THEN
     REFX = (REFTAB(IREFTAB,2)+(TIME-REFTAB(IREFTAB,1))*
&        (REFTAB(IREFTAB+1,2)-REFTAB(IREFTAB,2))/
&         (REFTAB(IREFTAB+1,1)-REFTAB(IREFTAB,1)))
   ELSE
    REFX= REFTAB(IREFTAB,2)
   ENDIF
 ENDIF
  ENDIF
ELSE
REFX=1.
ENDIF
!!! End of reftab 
!! End of parameter setting and initiations of THYRAVR4_PSS.

!! Here starts the dynamic part of process THYRAVR4_PSS.
!! First-order filter with filter constant TU.
   IF (START00) THEN
      V1=VC
   ELSE
      V1: V1=VC-TU*.D/DT.V1
   ENDIF
!! A signal subtracted to the reference, Reference.
   V2=REF*REFX-V1                                        !AH revisjon *REFX
!! Summation of two signals.
   V7=VS+V2
!! Multiplication of two signals.
   V4=KD*V7
!! Filtered deriving function s/(1+sTD).
   INTER_1=V4/TD
   INTER_2: INTER_2=INTER_1-TD*.D/DT.INTER_2
   V5=INTER_1-INTER_2
!! Multiplication of two signals.
   V3=KP*V7
!! An integrator of non-wind-up type with integral time TI.
   IF (V6.GE.IMAX.AND.
&      V3.GE.0.AND..NOT.START) THEN
      V6=IMAX
      PRINT-I'V6 is at maximum limit.'
   ELSEIF (V6.LE.IMIN.AND.
&      V3.LT.0.AND..NOT.START) THEN
      V6=IMIN
      PRINT-I'V6 is at minimum limit.'
   ELSE
      V6: TI*.D/DT.V6=V3
      PRINT'V6 is within limits.'
   ENDIF
!! Summation of three signals.
   V8=V6+V3+V5
!! Limiter, MFCL <= UC <= OELf.
!! Checking the limits of the Limit function.
   IF (OELf.LT.MFCL) THEN
      STOP'The upper limit is lower than the lower limit.'
   ENDIF
   IF (V8.GE.OELf.AND..NOT.START) THEN
      UC=OELf
      PRINT-I'UC is at maximum limit.'
   ELSEIF (V8.LE.MFCL.AND..NOT.START) THEN
      UC=MFCL
      PRINT-I'UC is at minimum limit.'
   ELSE
      UC=V8
      PRINT'UC is within limits.'
   ENDIF
!! First-order filter with filter constant TBR
!! and the constant KBR in the numerator.
   IF (START00) THEN
      UF=KBR*UC
   ELSE
      UF: UF=KBR*UC-TBR*.D/DT.UF
   ENDIF
!! Initial control of some of the block diagrams.
   IF (START) THEN
!! Checks start conditions by setting REF.
      REF: UF=UF0
!! A check of the filtered deriving function s/(1+sTD).
      IF (TD.LE.0) THEN
         STOP'Time constant TD in block s/(1+sTF) less or equal zero!'
      ENDIF
   ENDIF
!! End of initial control of some of the block diagrams.
!! Control of block diagram outputs within given limits.
   IF (.NOT.START.AND.CHECK_OF_LIMITS.EQ.0) THEN
!! An integrator of non-wind-up type with integral time TI.
!! This is a start-up check.
      IF (V6.GE.IMAX.AND.
&         V3.GT.0.OR.
&         V6.GT.IMAX) THEN
         STOP'V6 is at maximum limit.'
      ELSEIF (V6.LE.IMIN.AND.
&      V3.LT.0.OR.
&      V6.LT.IMIN) THEN
         STOP'V6 is at minimum limit.'
      ENDIF
      IF (V8.GE.OELf) THEN
         PRINT-I'UC is at maximum limit.'
      ELSEIF (V8.LE.MFCL) THEN
         PRINT-I'UC is at minimum limit.'
      ENDIF
      CHECK_OF_LIMITS=1
   ENDIF
!! End of control of block diagram outputs within given limits.
END
!! End of THYRAVR4_PSS.                :-)
