!! *--------   DSL Code Generator, continuous processes   --------
!! *
!! *           Name    : EXC_HTG
!! *           Function: A regulator
!! *                     
!! *           DSL Code Generator, release: 2000-06-11.
!! *           This is the 2nd release of the software.
!! *--------------------------------------------------------------
!! Copyright ABB Power Systems, Sweden.
!! Department : POW/RN
!! Designed by: Jonas Persson.
!! Checked by : Lars Lindquist
!! Approved by: Sture Torseng
!! Released   : 2000-08-24
!! *--------------------------------------------------------------

PROCESS EXC_HTG(VC,TR,KA,VS,UF,UF0)
EXTERNAL VC,TR,KA,VS,UF0
!! End of external declarations.
REAL     VC,TR,KA,VS,V1,VREF/*/
REAL     V2,UF0,V3,UF
!! End of real declarations.
PLOT     V3,UF
STATE    V1
!! End of state declarations.
   IF (START) THEN
   ENDIF
!! End of parameter setting and initiations of EXC_HTG.

!! Here starts the dynamic part of process EXC_HTG.
!! First-order filter with filter constant TR.
   V1: V1=VC-TR*.D/DT.V1
!! A signal added to the reference.
   V2=VREF-V1
!! Summation of two signals.
   V3=V2+VS
!! Multiplies two signals.
   UF=KA*V3
   IF (START) THEN
!! Checks start conditions by setting VREF.
      VREF: UF=UF0
   ENDIF
END
!! End of EXC_HTG.                :-)
